class HELLO2

inherit
	GTK_APPLICATION

creation 
	make
	
feature 
			--
	
	make is 
		do
			initialize_tool_kit;
			-- mu sein 
			!!window.make_top_level;
			-- Fenster anlegen
			window.set_border_width(10);
			-- Platz schaffen fr Buttons (so kann man sie wenigstens erkennen)
			make_buttons;
			-- `quit' und `hello' button anlegen
			make_commands; 
			-- Kommandos initialisieren
			connect_buttons_with_commands;
			-- buttons mit Kommandos verbinden
			!!box.make_horizontal(False, 2);
			-- horizontale Anordnung der Buttons
			pack_buttons;
			-- buttons in `box' einfgen
			window.add_widget(box);
			-- `box' dem `window' bekannt machen
			show_all;
			-- alles sichtbar machen
			wait_for_events;
			-- Event-loop
		end;

	

feature {NONE}
	
	window: GTK_WINDOW;
			-- top-level window
	
	
	hello_button: GTK_BUTTON;
			-- ein Button
	hello_cmd: HELLO_COMMAND;
			-- gibt einen Text aus
	quit_cmd: QUIT_COMMAND
			-- `legales' Ende der Event-Schleife
	quit_button: GTK_BUTTON;

	wqc: WINDOW_QUIT_COMMAND;
			-- destroy-button des Fensters soll Programm auch beenden

	box: GTK_BOX;
	no_box_expand: BOOLEAN is False;
	no_box_fill: BOOLEAN is False;
	box_padding: INTEGER is 2;

	make_buttons is
		-- Buttons anlegen
		do
			!!quit_button.make_with_label("ENDE");
			!!hello_button.make_with_label("Klick mich;-)");
		end;

	make_commands is
			-- Kommandos anlegen
		do
			!!hello_cmd;
			!!quit_cmd;
			-- Quit auch mit dem Destroy-Button des Fensters verbinden
			!!wqc.make(window);
		end;
	
	
	
	connect_buttons_with_commands is
			-- Button mit commandos verbinden
		require
			existing_buttons: quit_button /= Void 
							  and then hello_button /= Void;
			existing_commands: quit_cmd /= Void 
							   and then hello_cmd /= Void; 
		do
			hello_button.add_action("clicked", hello_cmd);
			quit_button.add_action("clicked", quit_cmd);
		end;
	
	pack_buttons is
			-- buttons in `box' packen
		do
			box.pack(hello_button, 
					 True,
					 no_box_fill,
					 box_padding)
			box.pack(quit_button,
					 True,
					 no_box_fill,
					 box_padding);
		end;
	
	show_all is
		do
			hello_button.show;
			quit_button.show;
			box.show;
			window.show;
		end;

end
   
