class OK_CMD
	
inherit
	MY_COMMAND_WITH_TOOLTIPS
	
creation
	make
	
feature
	make (col_sel: like color_selector) is
		require
			col_sel_not_void: col_sel /= Void
		do
			color_selector := col_sel;
			tooltip.set_tool_tip("Mit OK werden die Farben im %
								 %Auswahlfenster bernommen", 
								 color_selector.ok);
		end;
	
	execute is 
		do
			color := color_selector.last_color_selected;
			set_new_color(color);
		end;
	
	
feature {NONE}
	
	set_new_color(col_arr: ARRAY[DOUBLE]) is
		require
			col_arr_exists: col_arr /= Void;
		do
			-- Array to external (aka POINTER) 
			-- nicht portabel, gilt fr SmallEiffel
			color_selector.selection.selection_set_color(col_arr.to_external);
		end;
	
	color : ARRAY[DOUBLE];


end
   
